#ifndef __MV_FLOW__
#define __MV_FLOW__

#include "MVInterface.h"
#include "SimpleResize.h"
#include "yuy2planes.h"

class MVFlow : public GenericVideoFilter, public MVFilter {

private:

   MVClip mvClip;
   int time256;
   int mode;
   bool fields;
//   PClip pelclip;
   bool isse;
   bool planar;

   PClip finest; // v2.0

   short *VXFullY; // fullframe vector mask
   short *VXFullUV;
   short *VYFullY;
   short *VYFullUV;

   short *VXSmallY; // Small vector mask
   short *VXSmallUV;
   short *VYSmallY;
   short *VYSmallUV;

	int nBlkXP;
	 int nBlkYP;
	 int nWidthP;
	 int nHeightP;
	 int nWidthPUV;
	 int nHeightPUV;

   int VPitchY;
   int VPitchUV;

   int nWidthUV;
   int nHeightUV;

	 int nHPaddingUV;
	 int nVPaddingUV;

   SimpleResize *upsizer;
   SimpleResize *upsizerUV;
	void Fetch(BYTE * pdst, int dst_pitch, const BYTE *pref, int ref_pitch,  short *VXFull, int VXPitch,  short *VYFull, int VYPitch, int width, int height, int time256);
	void Shift(BYTE * pdst, int dst_pitch, const BYTE *pref, int ref_pitch,  short *VXFull, int VXPitch,  short *VYFull, int VYPitch, int width, int height, int time256);

	YUY2Planes * DstPlanes;

public:
	MVFlow(PClip _child, PClip _super, PClip _vectors, int _time256, int _mode, bool _fields,
                int nSCD1, int nSCD2, bool isse, bool _planar, IScriptEnvironment* env);
	~MVFlow();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

#endif
